// dsc_mpe_can2l_demo.c : Defines the entry point for the console application.
//

#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <sys/time.h>

static int kbhit()
{
	struct timeval timeout;
	fd_set rfds;

	timeout.tv_sec = 0;
	timeout.tv_usec = 0;

	FD_ZERO(&rfds);
	FD_SET(0, &rfds);

	if ( select(0+1, &rfds, NULL, NULL, &timeout) > 0 )
		return getchar();

	return 0;
}


#include "../CANLib/libcan.h"

#define MAX_CAN 2
int fd[MAX_CAN];



int main()
{
	char input_buffer[20];
	int index=0;
	int can_port=0;
	int brate_index=0;
	int i=0,j=0;
	FILE *fp =NULL;
	FILE *fp1 = NULL;
	char txbuff[256];
	char txbuff1[256];
	unsigned char data[16];
	unsigned char rx_data[16];
	unsigned char data1[16];
	unsigned char rx_data1[16];
	int can_fd;
	unsigned char  msgType;
	unsigned int can_id;
	unsigned char len;
	int rtr;
	
	int temp;
	int ret =0;
	int mode=0;
	
	printf ( "\nDSC_MPECAN2L_DEMO Application\n" );
	
	// Log for CAN_Receive 	
	fp1=fopen("CAN_Transmit_Log.txt","w");
	if(fp1==NULL)
	{
			perror("fopen:");
	}
	fflush(fp1);
	sprintf(txbuff1," CAN_ID   MSG_TYPE RTR    Len  Data                         \n");
	fprintf(fp1,"%s",txbuff1);
	// Log for CAN_Receive 	
	fp=fopen("CAN_Receive_Log.txt","w");
	if(fp==NULL)
	{
			perror("fopen:");
	}
	fflush(fp);
	sprintf(txbuff," CAN_ID   MSG_TYPE RTR    Len  Data                         \n");
	
	
	fprintf(fp,"%s",txbuff);

	printf ( "Enter the CAN Port number [0-CAN0,1-CAN1]:");
	fgets ( input_buffer, 20, stdin );
	if ( input_buffer[0] == '\n' )
	{
		can_port =i;
	}
	else
	{
		sscanf( input_buffer, "%x", &can_port );
	}
	printf ( "Enter the CAN Port %d for baudrate[0-1M,1-800K,2-500k,3-250K,4-125K,5-100K,6-50k,7-20K,8-10K] : ",can_port);
	fgets ( input_buffer, 20, stdin );
	if ( input_buffer[0] == '\n' )
	{
		brate_index =0;
	}
	else
	{
		sscanf( input_buffer, "%x", &brate_index );
	}


	if(can_port==0)		
	{
	  fd[can_port] = init_can0();
	  if(fd[can_port] == -1)
	  {
		   return 0;
	  }
	  set_baudrate(fd[can_port] , brate_index);
	}
	else
	{
	  fd[can_port] = init_can1();
	  if(fd[can_port] == -1)
	  {
		   return 0;
	  }
	  set_baudrate(fd[can_port] , brate_index);
	}
	
	printf("Enter the CAN Operation [0-Tx,1-RX] :");
	fgets ( input_buffer, 20, stdin );
	if ( input_buffer[0] == '\n' )
	{
		printf("MSGType with STD:0  \n");
		mode = 0;
	}
	else
	{
		sscanf( input_buffer, "%x", &mode );
	}
	
	if(mode==0)// Tx_mode Enabled
	{

		printf ( "Enter the CAN %d Message Type [0-STD,1-EXT] :",can_port);
		fgets ( input_buffer, 20, stdin );
		if ( input_buffer[0] == '\n' )
		{
			msgType = 0;
		}
		else
		{
			sscanf( input_buffer, "%x", &temp );
			msgType = temp;	
		}
	
		printf ( "Enter the CAN %d MSG_ID    : ",can_port);
		fgets ( input_buffer, 20, stdin );
		if ( input_buffer[0] == '\n' )
		{
			can_id = 0x7b;
		}
		else
		{
			sscanf( input_buffer, "%x", &temp );
			can_id = temp;	
		}
	
		
		printf ( "Enter the RTR  [0-Disable,1-Enable] :" );
		fgets ( input_buffer, 20, stdin );
		if ( input_buffer[0] == '\n' )
		{
			rtr = 0x0;
		}
		else
		{
			sscanf( input_buffer, "%x", &temp );
			rtr = temp;	
		}
		printf(" CAN %d selected for Tx\n",can_port);
		printf(" Press any Key to end the operation \n");
		i=0;
		while(!kbhit())
		{
			len=0x8; //Data length
			for(j=0;j<len;j++){
				data[j]= i+j;
			}
			strcat(txbuff1," ");
			sprintf(txbuff1,"  %x        %x      %x      %x    0x%x-0x%x-0x%x-0x%x-0x%x-0x%x-0x%x-0x%x    ",can_id,msgType,rtr,len,data[0],data[1],data[2],data[3],data[4],data[5],data[6],data[7]);
			fprintf(fp1," %s \n",txbuff1); 
			
			ret = can_tx(fd[can_port], msgType,  can_id, len,rtr,data);

			if(ret ==-1)
			printf("Error in transmit for %d \n",can_port);
			
			i++;
			if(i>15)
			{
				i=0;
			}
			
			usleep(2000);//2msec delay
		
		}	
		fclose(fp1);

	}
	else
	{
		printf(" CAN %d selected for RX\n",can_port);
		printf(" Press any Key to end the operation \n");		
		while(!kbhit())
		{
		ret = can_rx(fd[can_port],&RxMsg);
		if(ret ==-1 || ret < 0)
		{
			printf("Error in receive for %d \n",can_port);
		}
		if(RxMsg[0].Msg_ID !=0)
		{		
		
			for(i=0;i<RxMsg[0].Rcv_msg_count;i++)
			{

			strcat(txbuff," ");
			sprintf(txbuff,"  %x        %x      %x      %x    0x%x-0x%x-0x%x-0x%x-0x%x-0x%x-0x%x-0x%x    ",RxMsg[i].Msg_ID,RxMsg[i].Msg_Type,RxMsg[i].Rtr,RxMsg[i].Msg_len,RxMsg[i].Data[0],RxMsg[i].Data[1],RxMsg[i].Data[2],RxMsg[i].Data[3],RxMsg[i].Data[4],RxMsg[i].Data[5],RxMsg[i].Data[6],RxMsg[i].Data[7]);
		
			}
			fprintf(fp," %s \n",txbuff);
		
		}
		RxMsg[0].Msg_ID =0;
		
			
		usleep(2000);//2msec delay
		}
		printf("CAN %d receive log is saved to CAN_Receive_Log.txt file.\n",can_port);
	}
	
	fclose(fp);
	

	can_close(fd[can_port]);
	
	printf ( "DSC_MPECAN2L_DEMO Application Closed\n" );
	return 0;
}

